// TConnect TestDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "TConnect Test.h"
#include "TConnect TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTConnectTestDlg Dialogfeld

CTConnectTestDlg::CTConnectTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTConnectTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTConnectTestDlg)
	m_data = _T("");
	m_bytes = 0;
	m_sDataIn = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTConnectTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTConnectTestDlg)
	DDX_Text(pDX, IDC_DATA_EDIT, m_data);
	DDX_Text(pDX, IDC_BYTES_EDIT, m_bytes);
	DDX_Text(pDX, IDC_DATA_READ, m_sDataIn);
	DDX_Control(pDX, IDC_TCONNECTOR21, m_TConnect);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTConnectTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTConnectTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_EXIT, OnExit)
	ON_BN_CLICKED(IDC_OPEN_BUTTON, OnOpenButton)
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, OnCloseButton)
	ON_BN_CLICKED(IDC_WRITE_BUTTON, OnWriteButton)
	ON_BN_CLICKED(IDC_PROPERTIES_BUTTON, OnPropertiesButton)
	ON_BN_CLICKED(IDC_READ_BUTTON, OnReadButton)
	ON_BN_CLICKED(IDC_chkDataEvent, OnchkDataEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTConnectTestDlg Nachrichten-Handler

BOOL CTConnectTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.
	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CTConnectTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CTConnectTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CTConnectTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//******************************************************************
//				OPEN & CLOSE THE DEVICE
//******************************************************************

void CTConnectTestDlg::OnOpenButton() 
{

  TRY
  {
    //Open TConector
	  m_TConnect.Open();
  }
  CATCH (COleDispatchException, pEx)
  {
    // note: you can get a File not found (port does not exist)
    // or an Access denied exception (other software already uses the port)
    MessageBox(m_TConnect.TranslateErrorNo(pEx->m_scError), "Open failed");
  }
  END_CATCH

  // successful opened?
  if(m_TConnect.GetIsOpen())
  {
	  UpdateData(FALSE);

	  //enable/disable Buttons
	  GetDlgItem(IDC_OPEN_BUTTON)->EnableWindow(FALSE);
    GetDlgItem(IDC_PROPERTIES_BUTTON)->EnableWindow(FALSE);
	  GetDlgItem(ID_EXIT)->EnableWindow(FALSE);

	  GetDlgItem(IDC_CLOSE_BUTTON)->EnableWindow(TRUE);
	  GetDlgItem(IDC_WRITE_BUTTON)->EnableWindow(TRUE);
    GetDlgItem(IDC_READ_BUTTON)->EnableWindow(TRUE);
  }
}

void CTConnectTestDlg::OnCloseButton() 
{
	//Close TConector
	m_TConnect.Close();

	//enable/disable Buttons
	GetDlgItem(IDC_OPEN_BUTTON)->EnableWindow(TRUE);
  GetDlgItem(IDC_PROPERTIES_BUTTON)->EnableWindow(TRUE);

	GetDlgItem(ID_EXIT)->EnableWindow(TRUE);

	GetDlgItem(IDC_CLOSE_BUTTON)->EnableWindow(FALSE);
	GetDlgItem(IDC_WRITE_BUTTON)->EnableWindow(FALSE);
  GetDlgItem(IDC_READ_BUTTON)->EnableWindow(FALSE);
}

//******************************************************************
//				WRITE TO DEVICE/INTERFACE (SYNCRONOUS)
//******************************************************************

void CTConnectTestDlg::OnWriteButton() 
{
	long lBytes, lTimeout;
	CString sData;

	UpdateData(TRUE);
	
	//setting values
	sData = m_data;
	lBytes = m_data.GetLength();
	lTimeout = 2000;

	//Send Data
	m_bytes = m_TConnect.Write(lBytes, lTimeout, (LPCTSTR) sData);

  // recommended - use a TRY / CATCH block like in read()

	//write no. of bytes to IDC_BYTES_EDIT
	UpdateData(FALSE);	
}


//******************************************************************
//				READ FROM DEVICE/INTERFACE (ASYNCHRONOUS)
//******************************************************************

void CTConnectTestDlg::OnReadButton() 
{
	// TODO: Add your control notification handler code here

long lBytes, lTimeout;

  lBytes = 20;
  lTimeout = 3000;

	UpdateData(TRUE);

  m_sDataIn.Empty();

  TRY
  {
    CWaitCursor cw; // show wait cursor until data was received

    m_sDataIn = m_TConnect.Read(lBytes, lTimeout); // read 20 Bytes within 3 sec
  }
  CATCH (CException, pEx)
  {
    // exception will be raised if not data could be received
    this->MessageBox("Timeout - no data received", "Error", MB_OK);
    m_sDataIn.Empty();
  }
  END_CATCH

  UpdateData(FALSE);	
}


BEGIN_EVENTSINK_MAP(CTConnectTestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTConnectTestDlg)
	ON_EVENT(CTConnectTestDlg, IDC_TCONNECTOR21, 1 /* OnData */, OnOnDataTconnector21, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


//******************************************************************
//				ONDATA EVENT HANDLER (ASYNC MODE with StartListen)
//******************************************************************

void CTConnectTestDlg::OnOnDataTconnector21(LPCTSTR Data) 
{
	// TODO: Add your control notification handler code here
  this->MessageBox(Data, "OnData event - data received");
	
}

///////////////////////////////////////////////////////
//  Enable / Disable Async Mode (OnData)
///////////////////////////////////////////////////////
void CTConnectTestDlg::OnchkDataEvent() 
{
	// TODO: Add your control notification handler code here
//  CWnd* chkDataEv = this->GetDlgItem(IDC_chkDataEvent);

  if (this->IsDlgButtonChecked(IDC_chkDataEvent))
  {
    m_TConnect.StartListen(); // now wait for OnData event
    GetDlgItem(IDC_READ_BUTTON)->EnableWindow(FALSE);
  }
  else
  {
    m_TConnect.StopListen(); // disable OnData event
    GetDlgItem(IDC_READ_BUTTON)->EnableWindow(TRUE);
  }
}

void CTConnectTestDlg::OnExit() 
{
	//Exit
	OnOK();
}

void CTConnectTestDlg::OnPropertiesButton() 
{
	//opens the PropertyDialog
	m_TConnect.PropertyDialog();
}
